<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
<#assign hasMQConsumer=false>
<#comment>实体中配置输入数据同步</#comment>
<#list sys.getAllPSDataEntities() as dataEntity>
    <#if dataEntity.getAllPSDEDataSyncs?? && dataEntity.getAllPSDEDataSyncs()??>
        <#list dataEntity.getAllPSDEDataSyncs() as dataSync>
            <#if dataSync.getInPSSysDataSyncAgent?? && dataSync.getInPSSysDataSyncAgent()??>
                <#assign hasMQConsumer=true>
                <#break >
            </#if>
        </#list>
    </#if>
</#list>
<#if hasMQConsumer>
    <#comment>服务接口微服务平台配置</#comment>
    <#assign mqServerAddress="">
    <#if sys.getAllPSDevSlnMSDepAPIs()??>
        <#list sys.getAllPSDevSlnMSDepAPIs() as depSysApi>
            <#if depSysApi.getPSDCMSPlatform()?? >
                <#if depSysApi.getUserParam("rocketmq.consumer.namesrvAddr","")??>
                    <#assign mqServerAddress = depSysApi.getUserParam("rocketmq.consumer.namesrvAddr","")>
                </#if>
            </#if>
        </#list>
    </#if>
    <#if mqServerAddress!=''>
        <#assign mqServer="on">
    <#else>
        <#assign mqServer="off">
    </#if>
package ${pub.getPKGCodeName()}.core.util.config;

import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSON;
import org.apache.rocketmq.client.consumer.listener.ConsumeOrderlyContext;
import org.apache.rocketmq.client.consumer.listener.ConsumeOrderlyStatus;
import org.apache.rocketmq.client.consumer.listener.MessageListenerOrderly;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.apache.rocketmq.common.message.MessageExt;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;
import java.util.List;

/**
 * MQ订阅消息处理
 */
@Slf4j
@Component
@ConditionalOnExpression("'${r'${rocketmq.consumer.isOnOff:'+mqServer+"}'.equals('on')"}")
public class RocketMQListenerProcessor implements MessageListenerOrderly {

    <#list sys.getAllPSDataEntities() as dataEntity>
        <#if dataEntity.getAllPSDEDataSyncs?? && dataEntity.getAllPSDEDataSyncs()??>
            <#list dataEntity.getAllPSDEDataSyncs() as dataSync>
                <#if dataSync.getInPSSysDataSyncAgent?? && dataSync.getInPSSysDataSyncAgent()?? &&dataSync.getInTestPSDEAction?? && dataSync.getInTestPSDEAction()??>
                    <#assign entityName=dataEntity.getCodeName()>
                    <#if !P.exists(entityName,"service")>
    @Autowired
    @Lazy
    ${pub.getPKGCodeName()}.core.${dataEntity.getPSSystemModule().getCodeName()?lower_case}.service.I${entityName}Service ${entityName}Service;
                    </#if>
                </#if>
            </#list>
        </#if>
    </#list>

    @Override
    public ConsumeOrderlyStatus consumeMessage(List<MessageExt> list, ConsumeOrderlyContext consumeOrderlyContext) {
        if (CollectionUtils.isEmpty(list)) {
            log.info("MQ接收消息为空，直接返回成功");
            return ConsumeOrderlyStatus.SUCCESS;
        }
        for (MessageExt messageExt : list) {
            log.info("MQ接收到的消息为：" + messageExt.toString());
            try {
                String topic = messageExt.getTopic();
                String tags = messageExt.getTags();
                String body = new String(messageExt.getBody(), "utf-8");
                log.info("MQ消息topic={}, tags={}, 消息内容={}", topic, tags, body);
            <#list sys.getAllPSDataEntities() as dataEntity>
                <#if dataEntity.getAllPSDEDataSyncs?? && dataEntity.getAllPSDEDataSyncs()??>
                    <#list dataEntity.getAllPSDEDataSyncs() as dataSync>
                        <#if dataSync.getInPSSysDataSyncAgent?? && dataSync.getInPSSysDataSyncAgent()??>
                            <#assign dataSyncCodeName=dataSync.codeName?lower_case>
                            <#if dataSync.getInTestPSDEAction?? && dataSync.getInTestPSDEAction()??>
                                <#assign inputAction=srfmethodname(dataSync.getInTestPSDEAction().codeName)>
                if ("${dataSyncCodeName}".equalsIgnoreCase(tags)) {
                    ${pub.getPKGCodeName()}.core.${dataEntity.getPSSystemModule().getCodeName()?lower_case}.domain.${entityName} domain = JSON.parseObject(new String(body),${pub.getPKGCodeName()}.core.${dataEntity.getPSSystemModule().getCodeName()?lower_case}.domain.${entityName}.class);
                                <#if inputAction.getCodeName()?lower_case == 'get' || inputAction.getCodeName()?lower_case == 'remove'>
                    ${entityName}Service.${inputAction}(domain.get${srfcaseformat(keyfield.codeName,'l_u2lC')?cap_first}());
                                <#else>
                    ${entityName}Service.${inputAction}(domain);
                }
                                </#if>
                            <#else>
                log.info("接收到[{}]消息，但未配置实体输入过滤行为，消息将被忽略。"+new String(msg.getBody()));
                            </#if>
                        </#if>
                    </#list>
                </#if>
            </#list>
            } catch (Exception e) {
                log.error("获取MQ消息内容异常{}", e);
            }

        }
        return ConsumeOrderlyStatus.SUCCESS;
    }
}
</#if>